io.vertx.rxjava.core.http

## Interface WebSocketBase

- All Superinterfaces:
    ReadStream<Buffer>, StreamBase, WriteStream<Buffer>
  All Known Implementing Classes:
    ServerWebSocket, WebSocket

      public interface WebSocketBase
      extends ReadStream<Buffer>, WriteStream<Buffer>

  Base WebSocket implementation.

  It implements both and so it can be used with `Pump` to pump data with flow control.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `binaryHandlerID()` When a `Websocket` is created it automatically registers an event handler with the event bus - the ID of that handler is given by this method.
    `void` | `close()` Close the WebSocket.
    `WebSocketBase` | `closeHandler(Handler<Void> handler)` Set a close handler.
    `WebSocketBase` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `WebSocketBase` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `WebSocketBase` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `WebSocketBase` | `frameHandler(Handler<WebSocketFrame> handler)` Set a frame handler on the connection.
    `Object` | `getDelegate()`
    `WebSocketBase` | `handler(Handler<Buffer> handler)` Set a data handler.
    `SocketAddress` | `localAddress()`
    `static WebSocketBase` | `newInstance(WebSocketBase arg)`
    `WebSocketBase` | `pause()` Pause the `ReadSupport`.
    `SocketAddress` | `remoteAddress()`
    `WebSocketBase` | `resume()` Resume reading.
    `WebSocketBase` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `String` | `textHandlerID()` When a `Websocket` is created it automatically registers an event handler with the eventbus, the ID of that handler is given by `textHandlerID`.
    `WebSocketBase` | `write(Buffer data)` Write some data to the stream.
    `WebSocketBase` | `writeBinaryMessage(Buffer data)` Writes a (potentially large) piece of binary data to the connection.
    `WebSocketBase` | `writeFinalBinaryFrame(Buffer data)` Write a final WebSocket binary frame to the connection
    `WebSocketBase` | `writeFinalTextFrame(String text)` Write a final WebSocket text frame to the connection
    `WebSocketBase` | `writeFrame(WebSocketFrame frame)` Write a WebSocket frame to the connection
    `boolean` | `writeQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.ReadStream

      `newInstance, toObservable`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.WriteStream

      `newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.StreamBase

      `newInstance`

- - ### Method Detail

    - #### getDelegate

          Object getDelegate()

      Specified by:
        `getDelegate` in interface `ReadStream<Buffer>`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Buffer>`

    - #### writeQueueFull

          boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Buffer>`
      Returns:
        true if write queue is full

    - #### exceptionHandler

          WebSocketBase exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          WebSocketBase handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          WebSocketBase pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadSupport`. While it's paused, no data will be sent to the `dataHandler`
      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          WebSocketBase resume()

      Description copied from interface: `ReadStream`
      Resume reading. If the `ReadSupport` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          WebSocketBase endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          WebSocketBase write(Buffer data)

      Description copied from interface: `WriteStream`
      Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pump`.
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          WebSocketBase setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` bytes in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          WebSocketBase drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue has been reduced to maxSize / 2. See `Pump` for an example of this being used.
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### binaryHandlerID

          String binaryHandlerID()

      When a `Websocket` is created it automatically registers an event handler with the event bus - the ID of that handler is given by this method.

      Given this ID, a different event loop can send a binary frame to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other WebSockets which are owned by different event loops.

      Returns:
        the binary handler id

    - #### textHandlerID

          String textHandlerID()

      When a `Websocket` is created it automatically registers an event handler with the eventbus, the ID of that handler is given by `textHandlerID`.

      Given this ID, a different event loop can send a text frame to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other WebSockets which are owned by different event loops.

      Returns:

    - #### writeFrame

          WebSocketBase writeFrame(WebSocketFrame frame)

      Write a WebSocket frame to the connection
      Parameters:
        `frame` - the frame to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeFinalTextFrame

          WebSocketBase writeFinalTextFrame(String text)

      Write a final WebSocket text frame to the connection
      Parameters:
        `text` - The text to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeFinalBinaryFrame

          WebSocketBase writeFinalBinaryFrame(Buffer data)

      Write a final WebSocket binary frame to the connection
      Parameters:
        `data` - The data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeBinaryMessage

          WebSocketBase writeBinaryMessage(Buffer data)

      Writes a (potentially large) piece of binary data to the connection. This data might be written as multiple frames if it exceeds the maximum WebSocket frame size.
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### closeHandler

          WebSocketBase closeHandler(Handler<Void> handler)

      Set a close handler. This will be called when the WebSocket is closed.
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### frameHandler

          WebSocketBase frameHandler(Handler<WebSocketFrame> handler)

      Set a frame handler on the connection. This handler will be called when frames are read on the connection.
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### close

          void close()

      Close the WebSocket.

    - #### remoteAddress

          SocketAddress remoteAddress()

      Returns:
        the remote address for this socket

    - #### localAddress

          SocketAddress localAddress()

      Returns:
        the local address for this socket

    - #### newInstance

          static WebSocketBase newInstance(WebSocketBase arg)

Copyright © 2015. All Rights Reserved.